
// arithm.h : arithmetic operations with overflow check.

/***************************************************************************/

#if 1

typedef __int64 INTEGER;
#define MIN_INTEGER  (-(INTEGER)9223372036854775808)
#define MAX_INTEGER  ((INTEGER)9223372036854775807)

#else

typedef signed char INTEGER;
#define MIN_INTEGER  (-128)
#define MAX_INTEGER  (127)

#endif

/***************************************************************************/

// returns 0 if OK or -1 if overflow

int add_int (INTEGER a, INTEGER b, INTEGER *r);
int sub_int (INTEGER a, INTEGER b, INTEGER *r);
int mul_int (INTEGER a, INTEGER b, INTEGER *r);
int div_int (INTEGER a, INTEGER b, INTEGER *r);
int mod_int (INTEGER a, INTEGER b, INTEGER *r);
int neg_int (INTEGER a, INTEGER *r);

/***************************************************************************/
