
// codgen.h : code generator

//======================================================================================

extern PENTITY func_main;
extern bool    function_main_has_parameter_array_of_string;

//======================================================================================

void generate_code (char *exec_filename, char *res_filename, char *debug_filename, bool option_crc);

//======================================================================================

void add_function_to_pending_functions (PENTITY e);

//======================================================================================

void add_global_variable_to_list (PENTITY e);

//======================================================================================

// frame info collects data for a whole function, from enter to leave, declarations and statements

typedef struct {
  
  int8 currently_pushed_offset;   // bytes currently pushed on stack (must be zero when function ends)
  
  int8 param_offset;  // size of all parameters reserved on stack for this function + 2 * address_size
                      // used by parameters, return address, frame pointer (>=0)
                      
  int8 frame_offset;  // local variables address relative to EBP (<=0)
  
  int8 minimum_frame_offset;  // smallest frame_offset ever reached (for local variables & temporaries)
  
} FRAME_INFO;

int4 allocate_temp_variable (int4 size, FRAME_INFO *frame);
int8 allocate_global_variable (int4 size);

//======================================================================================

int get_new_near_label_nr ();
int get_new_func_label_nr ();

//======================================================================================

// returns true if code after region is unreachable

bool generate_code_for_region (wstring    func_id,
                               PENTITY    e_parent,
                               PENTITY    e_list,
                               FRAME_INFO *frame,
                               int        outer_label_break,
                               int        outer_label_continue,
                               bool       *any_jumps_to_label_break,
                               bool       *any_jumps_to_label_continue);

//======================================================================================

// for k_typ below

#define K_FOR           0x01
#define K_WHILE         0x02
#define K_SWITCH        0x04

//======================================================================================

// returns true if code was generated, false otherwise

bool release_objects_in_outer_scope (int     k_typ,
                                     PENTITY e_parent,
                                     bool    b_generate_code);

//======================================================================================

void generate_p_location (LOCATION *l);

//======================================================================================
