
// exp.h

//*****************************************************************************

void parse_expression (PCONTEXT      context,           // never null
                       TEXT_POSITION *prefix_position,  // never null
                       PENTITY       prefix_name,       // can be null
                       PEXPRESSION   *pout);

void parse_unary_expression (PCONTEXT      context,           // never null
                             TEXT_POSITION *prefix_position,  // never null
                             PENTITY       prefix_name,       // can be null
                             PEXPRESSION   *out);

extern CONTEXT no_context;


//*****************************************************************************

void convert_type_into_context (PENTITY  type,      // in
                                PCONTEXT context);  // out

//*****************************************************************************

// returns 0 if OK, -1 if types are not compatible
// error message is generated in function

int check_assignment_context_compatibility (PCONTEXT target, PEXPRESSION source, TEXT_POSITION *pos);

//*****************************************************************************

// error message is generated in function
// used for parameter and ref declaration

int check_ref_parameter_context_compatibility (PCONTEXT target, PEXPRESSION source, TEXT_POSITION *pos);

//*****************************************************************************

int8 parse_constant_int_or_uint_expression (void);

//*****************************************************************************

PEXPRESSION parse_constant_expression (void);

//*****************************************************************************

PEXPRESSION parse_constant_expression (void);
PEXPRESSION parse_constant_expression_with_context (PCONTEXT context);

//*****************************************************************************

bool constant_expressions_match (PEXPRESSION e1, PEXPRESSION e2);

//*****************************************************************************

PEXPRESSION new_exp (KIND_EXPRESSION kind);

void free_exp (PEXPRESSION p);

//*****************************************************************************

PEXPRESSION dummy_expression ();

//*****************************************************************************
