
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include "binsort.h"

/**************************************************************************/

static void maximize (void   *table,
                      size_t element_size,
                      int    (*compare) (const void *p1, const void *p2),
                      char   *bubulle,    /* used as temporary storage */
                      size_t inf,
                      size_t sup)
{
  size_t i_pere, i_fils;

  memcpy (bubulle, &((char *)table)[(inf-1)*element_size], element_size);

  i_pere = inf;

  while (i_pere <= sup / 2)
  {
    i_fils = 2 * i_pere;

    if (i_fils < sup)    /* i_fils + 1 exists */
    {
      if (compare (&((char *)table)[(i_fils-1)*element_size],
                   &((char *)table)[(i_fils+(1-1))*element_size]) < 0)
        i_fils++;
    }

    if (compare (bubulle, &((char *)table)[(i_fils-1)*element_size]) < 0)
    {
      memcpy (&((char *)table)[(i_pere-1)*element_size],
              &((char *)table)[(i_fils-1)*element_size],
              element_size);

      i_pere = i_fils;
    }
    else
    {
      break;
    }
  }

  memcpy (&((char *)table)[(i_pere-1)*element_size], bubulle, element_size);
}

/**************************************************************************/

int binary_sort (void   *table,
                 size_t nb_elements,
                 size_t element_size,
                 int    (*compare) (const void *p1, const void *p2))
{
  char   *temp;
  size_t min, sup;

  temp = (char *)alloca (element_size);
  if (temp == (char *)0)
    return -1;

  min = nb_elements / 2;

  while (min >= 1)
  {
    maximize (table, element_size, compare, temp, min, nb_elements);
    min--;
  }

  sup = nb_elements;

  while (sup > 1)
  {
    memcpy (temp,
            &((char *)table)[0*element_size],
            element_size);

    memcpy (&((char *)table)[0*element_size],
            &((char *)table)[(sup-1)*element_size],
            element_size);

    memcpy (&((char *)table)[(sup-1)*element_size],
            temp,
            element_size);

    sup--;

    maximize (table, element_size, compare, temp, 1, sup);
  }

  return 0;
}

/**************************************************************************/
