
/* pack3.h */

/**************************************************************************/

#define OUTPUT_BUFFER_SIZE   32768

typedef struct {
  unsigned char buffer[OUTPUT_BUFFER_SIZE];
  int           count;   /* nb of complete bytes in buffer[] */
  unsigned char by;      /* new byte that is being built bit by bit */
  int           power;   /* power of 2 that will be added to 'by' next time */
                         /* when power == 128 is added, the byte is moved */
                         /* into buffer.                                  */
  IO_FUNC       *user_write;  /* function used to write a buffer */
  void          *user_info;
} OUTPUT_INFO;

/**************************************************************************/

static void init_output (OUTPUT_INFO *info,
                         IO_FUNC     *user_write,
                         void        *user_info); /* passed to user_write() */

/**************************************************************************/

#define MSB_FIRST  1
#define LSB_FIRST  2

static int send_code (OUTPUT_INFO *info, int code, int nb_bits, int bit_order);

/**************************************************************************/

/* flush the remaining bits (if any) of the current byte       */
/* in order to be on a byte boundary, then send the data block */

static int send_block (OUTPUT_INFO *info, unsigned char *data, int length);

/**************************************************************************/

/* send all remaining data to output device */

static int flush_output (OUTPUT_INFO *info);

/**************************************************************************/
