
/* tracing.h */

/************************************************************************/

/* create a new or append to an existing trace file.                    */

/* 'prefix_datestamp' : 1 = prefix "YY/MM/DD" to each line, 0 = not.    */
/* 'prefix_timestamp' : 1 = prefix "HH:MM:SS" to each line, 0 = not.    */
/* 'max_file_size'    : maximum allowed size of trace file before its   */
/*                      extension is renamed into '.old' and a new      */
/*                      empty file is created.                          */

void open_trace (char *filename,          /* for example "trace.tra"    */
                 int  prefix_datestamp,   /* 0 or 1 */
                 int  prefix_timestamp,   /* 0 or 1 */
                 long max_file_size);     /* for example 5*1024L for 5K */

/************************************************************************/

/* if 'format' ends with '\n', then the next line will start with       */
/* a date/timestamp prefix (if this was asked in the open_trace call)   */

void trace (char *format, ...);

/************************************************************************/

/* trace hexadecimal dump of a block of data */
void trace_block (unsigned char *block, unsigned int size);

/************************************************************************/

void close_trace (void);

/************************************************************************/
