
/* unpack1.h : Huffman Computation */

/***********************************************************************/

typedef struct {
  short code_length;  /* nb bits of huffman code_value (0 = unused) */
  short code_value;   /* value of huffman code                      */
  short index_zero;   /* index to node entry with zero bit (or -1)  */
  short index_one;    /* index to node entry with one bit (or -1)   */
} NODE;

/***********************************************************************/

#define MAX_CODE_BITS  15

/* build 'code_value', 'index_zero' and 'index_one' when code_length */
/* are already computed.                                             */

/* Attention: the caller must reserve 2*max_nodes entries in node[] */
/* (the first max_nodes entries contain the data, the second        */
/* contain the non-leaf nodes).                                     */
/* node[] should have been cleared with memset to 0x00.             */
/* the root of the tree will be at index (2*max_nodes-1).           */

static int compute_huffman (NODE *node, int max_nodes);

/***********************************************************************/

/* build 'index_zero' and 'build_one' when code_values are already computed */
static int build_huffman_tree (NODE *node, int max_nodes);

/***********************************************************************/
