
/* unpack4.c : output byte stream */

/**************************************************************************/

static void init_output (OUTPUT_INFO *info,
                         IO_FUNC     *user_write,
                         void        *user_info)  /* passed to user_write() */
{
  info->count      = 0;
  info->user_write = user_write;
  info->user_info  = user_info;
}

/**************************************************************************/

/* send all remaining data to output device */

static int flush_output (OUTPUT_INFO *info)
{
  int rc;

  rc = (*info->user_write) (info->user_info, info->buffer, info->count);
  if (rc != info->count)
    return UNPK_WRITE_ERROR;

  info->count = 0;

  return 0;
}

/**************************************************************************/

static int send_block (OUTPUT_INFO   *info,
                       unsigned char *data,
                       unsigned int  length)
{
  unsigned int i;
  int          rc;

  for (i=0; i<length; i++)
  {
    if (info->count == OUTPUT_BUFFER_SIZE)
    {
      rc = flush_output (info);
      if (rc)
        return rc;
    }

    info->buffer[info->count++] = data[i];
  }

  return 0;
}

/**************************************************************************/
