
/* unpack4.h */

/**************************************************************************/

#define OUTPUT_BUFFER_SIZE   32768

typedef struct {
  unsigned char buffer[OUTPUT_BUFFER_SIZE];
  int           count;        /* nb of bytes in buffer[] */
  IO_FUNC       *user_write;  /* function used to write a buffer */
  void          *user_info;
} OUTPUT_INFO;

/**************************************************************************/

static void init_output (OUTPUT_INFO *info,
                         IO_FUNC     *user_write,
                         void        *user_info); /* passed to user_write() */

/**************************************************************************/

static int send_block (OUTPUT_INFO   *info,
                       unsigned char *data,
                       unsigned int  length);

/**************************************************************************/

/* send all remaining data to output device */

static int flush_output (OUTPUT_INFO *info);

/**************************************************************************/
