
// strings.c

#include "strings.h"

/**********************************************************************/

int wstrlen (wstring s)
{
  int i = 0;
  while (s[i] != Lnul)
    i++;
  return i;
}

/**********************************************************************/

int wstrcmp (wstring a, wstring b)
{
  int i = 0;
  for (;;)
  {
    if (a[i] == b[i])
    {
      if (a[i] == Lnul)
        return 0;
      i++;
      continue;
    }
    if (a[i] < b[i])
      return -1;
    else
      return +1;
  }
}

/**********************************************************************/

void wstrcpy (wstring target, wstring source)
{
  int i = 0;
  while (source[i] != Lnul)
  {
    target[i] = source[i];
    i++;
  }
  target[i] = Lnul;
}

/**********************************************************************/

void wstring_to_string (wstring w, string s)
{
  int i = 0;
  while (w[i] != Lnul)
  {
    if (w[i] <= (wchar)255)
      s[i] = (char)w[i];
    else
      s[i] = '?';
    i++;
  }
  s[i] = nul;
}

/**********************************************************************/

void string_to_wstring (string s, wstring w)
{
  int i = 0;
  while (s[i] != nul)
  {
    w[i] = (wchar)s[i];
    i++;
  }
  w[i] = Lnul;
}

/**********************************************************************/

bool is_all_in_lowercase (wstring s)
{
  int i = 0;
  while (s[i] != Lnul)
  {
    if (s[i] >= 'A' && s[i] <= 'Z')
      return false;
    i++;
  }
  return true;
}

/**********************************************************************************/

bool is_all_in_uppercase (wstring s)
{
  int i = 0;
  while (s[i] != Lnul)
  {
    if (s[i] >= 'a' && s[i] <= 'z')
      return false;
    i++;
  }
  return true;
}

/**********************************************************************************/

bool has_at_least_one_letter (wstring s)
{
  int i = 0;
  while (s[i] != Lnul)
  {
    if (s[i] >= 'a' && s[i] <= 'z')
      return true;
    if (s[i] >= 'A' && s[i] <= 'Z')
      return true;
    i++;
  }
  return false;
}

/**********************************************************************************/

void to_lower_case (char *s)
{
  int i;

  for (i=0; s[i] != '\0'; i++)
    if (s[i] >= 'A' && s[i] <= 'Z')
      s[i] = s[i] - 'A' + 'a';
}

/**********************************************************************************/
