
// memory.c

use win/windows;



#begin unsafe

public byte *malloc (uint size)
{
  return (byte*)HeapAlloc (GetProcessHeap(), 4, size);
}

public void freem (byte *p)
{
  assert HeapFree (GetProcessHeap(), 0, p) != 0;
}

public uint heapsize (byte *p)
{
  return (uint)HeapSize (GetProcessHeap(), 0, p);
}

public byte *realloc (byte *p, uint size)
{
  byte *n = malloc (size);
  uint old_size = heapsize(p);
  n[0 : old_size] = p[0 : old_size];
  freem (p);
  return n;
}

#end unsafe
