
// system.c

use win/windows;

/***********************************************************************/
#begin unsafe
/***********************************************************************/

public void get_computer_name (out string(MAX_COMPUTERNAME_LENGTH) computer_name)
{
  uint siz = computer_name'size;
  if (GetComputerNameA (&computer_name, &siz) == 0)
    computer_name[0] = nul;
}

/***********************************************************************/

public void get_executable_filename (out string(MAX_EXECUTABLE_FILENAME_LENGTH) executable_filename)
{
  GetModuleFileNameA (0, &executable_filename, (DWORD)executable_filename'length);
}

/***********************************************************************/

public void wget_executable_filename (out wstring(MAX_EXECUTABLE_FILENAME_LENGTH) executable_filename)
{
  GetModuleFileNameW (0, &executable_filename, (DWORD)executable_filename'length);
}

/***********************************************************************/

public void get_login_userid (out string(MAX_USERID_LENGTH) userid)
{
  uint siz = userid'size;
  if (GetUserNameA (&userid, &siz) == 0)
    userid[0] = '\0';
}

/***********************************************************************/

// physical RAM on the PC

public long get_total_physical_RAM ()
{
  MEMORYSTATUSEX m;
  clear m;
  m.dwLength = m'size;
  GlobalMemoryStatusEx (&m);
  return m.ullTotalPhys;
}

/***********************************************************************/

// returns free memory (in bytes)

public long get_free_memory ()
{
  MEMORYSTATUSEX m;
  
  clear m;
  m.dwLength = m'size;
  GlobalMemoryStatusEx (&m);
  
#if MEM32  
  return m.ullAvailVirtual;
#else  
  return m.ullAvailPageFile;
#endif
}

//--------------------------------------------------------------------------

// A number between 0 and 100 that specifies the approximate percentage of physical memory 
// that is in use (0 indicates no memory use and 100 indicates full memory use).

public int get_virtual_memory_load ()
{
  MEMORYSTATUSEX m;

  clear m;
  m.dwLength = m'size;
  GlobalMemoryStatusEx (&m);

  return (int)m.dwMemoryLoad;
}

/***********************************************************************/

public int get_nb_of_cores ()
{
  SYSTEM_INFO v;
  GetSystemInfo (&v);
  return (int)v.dwNumberOfProcessors;
}

/***********************************************************************/

public void get_language (out uint lang, out uint sublang)
{
  uint l = GetUserDefaultLangID();

  lang    = ((ushort)l) & 0x3FF;
  sublang = ((ushort)l) >> 10;
}

/***********************************************************************/

// retrieve operating system directory ("c:\windows")

public void get_operating_system_directory (out char dir[260])
{
  clear dir;
  GetWindowsDirectoryA (&dir, dir'size-1);
}

/***********************************************************************/

public void get_country (out wchar[3] country)
{
  const string KERNEL32DLL = "kernel32.dll\0";
  const string GETUSERDEFAULTGEONAME = "GetUserDefaultGeoName\0";
  HMODULE h;
  PVOID   func;
  GetUserDefaultGeoName pGetUserDefaultGeoName;
  wchar name[4];

  clear country;

  h = GetModuleHandleA (&KERNEL32DLL);
  if (h == 0)
    return;
    
  func = GetProcAddress (h, &GETUSERDEFAULTGEONAME);
  *(LPVOID*)&pGetUserDefaultGeoName = func;

  if (pGetUserDefaultGeoName != null)
  {
    if (pGetUserDefaultGeoName (&name, name'length) != 0)
      country = name[0:3];
  }
}

/***********************************************************************/

public uint idle_msec ()
{
  LASTINPUTINFO info;
  
  clear info;
  info.cbSize = info'size;
  
  if (GetLastInputInfo (&info) == 1)
  {
    return GetTickCount() - info.dwTime;
  }
  else
  {
    return 0;
  }
}

/***********************************************************************/
#end unsafe
/***********************************************************************/
